/*

Directory handling

*/


typedef struct {
  void *next;
  void *prev;
  unsigned int size;
  unsigned char *name;
  unsigned char type;
} direntry;

typedef struct {
  unsigned char numentries;
  unsigned char *name;
  direntry *firstentry;
  unsigned char current;
  unsigned char offset;
} directory;


#define DIRTYPE_DEL   0
#define DIRTYPE_SEQ   1
#define DIRTYPE_PRG   2
#define DIRTYPE_USR   3
#define DIRTYPE_REL   4
#define DIRTYPE_CBM   5
#define DIRTYPE_DIR   6
#define DIRTYPE_OTHER 7

extern unsigned char *entrytype[];


/* Read directory */
directory *getdir(unsigned char direction, unsigned char *buffer, unsigned char devic);

/* Parse directory */
directory *parsedir(unsigned char *buffer, unsigned int length);

/* Free memory allocated to a dir structure */
void freedir(directory *dir);

/* Get a pointer to the entrynumth direntry */
direntry *getentry(directory *dir, unsigned char entrynum);
