/*

Serial port handling

gpz	added 20020828: ser_flush
					completed some void declarations (be a good boy mkay? ;=P)

*/


#define SER_TURBO232	1
#define SER_SILVER	2

#define SER_2400	0x06
#define SER_4800	0x07
#define SER_9600	0x08
#define SER_19200	0x09
#define SER_38400	0x0A
#define SER_57600	0x0B
#define SER_115200	0x0C
#define SER_230400	0x0D


/* initialize the serial port */
unsigned char ser_init(unsigned char interface, unsigned char baudrate);

/* call when done with the serial port */
void ser_exit(void);

/* get a byte from the serial port, blocking */
unsigned char ser_rx(void);

/* send a byte on the serial port */
void ser_tx(unsigned char byte);

/* get an LSB first 16-bit word */
unsigned int ser_getword(void);

/* send a string on the serial port */
void ser_send(unsigned char *string, unsigned char length);

/* read until no more incoming data is present */
void ser_flush(void);
