;---------------------------------------
; Serial port code
; gpz added 20020828: ser_flush (silversurfer only)

 ifconst A6551

; SwiftLink regs
arxd	= A6551BASE + 00
atxd	= A6551BASE + 00
asts	= A6551BASE + 01
ares	= A6551BASE + 01
acmd	= A6551BASE + 02
actl	= A6551BASE + 03
 ifconst T232
t232	= A6551BASE + 07
 endif


ser_init	sta ares	; reset 6551
	lda #$0b	; no parity, no echo
	sta acmd	; no irqs, rx/tx on
 ifconst T232
	lda #$10	; t232 mode
	sta actl
	lda #$01	; 115200 baud
	sta t232
 else
	lda #$1f	; 19200 or 38400 baud
	sta actl
 endif
	rts


ser_tx	pha
ser_txwait	lda asts	; check tx buffer
	and #$10
	beq ser_txwait	; full
	pla
	sta atxd	; transmit
	sta sborder
	rts


ser_rx	lda asts	; check rx buffer
	and #$08
	beq ser_rx	; empty
	lda arxd	; receive
	sta sborder
	rts

ser_flush
	rts

 endif


 ifconst A16550

;---------------------------------------
; 16550 code by groepaz@gmx.de

fifo_rxd	= A16550BASE + 0	; (r)
fifo_txd	= A16550BASE + 0	; (w)

fifo_dll	= A16550BASE + 0

fifo_dlm	= A16550BASE + 1
fifo_ier	= A16550BASE + 1

fifo_fcr	= A16550BASE + 2	; (w)
fifo_iir	= A16550BASE + 2	; (r)
fifo_lcr	= A16550BASE + 3
fifo_mcr	= A16550BASE + 4
fifo_lsr	= A16550BASE + 5
fifo_msr	= A16550BASE + 6	; (r)
fifo_scratch	= A16550BASE + 7	; (r/w)

 ifconst SILVER
ss_control	= $de01
 endif

; init the 16550
ser_init
 ifconst SILVER
	; enable ssurfer-port
	lda ss_control
	ora #1
	sta ss_control
 endif
	lda #%10000111
	sta fifo_fcr

	lda #%10000011	; set dlab
	sta fifo_lcr

	; set baudrate
	; $30    9600
	; $18   19200
	; $0c   38400
	; $08   57600
	; $04  115000
	lda #4
	sta fifo_dll
	lda #0
	sta fifo_dlm

	lda #%00000011	; reset dlab
	sta fifo_lcr

	lda #%00000000	; disable nmi's
	sta fifo_ier

	lda #%00000001	; activate dtr
	sta fifo_mcr

	rts


; receive a byte
ser_rx	subroutine
	lda fifo_lsr	; check if byte available
	and #$01
	bne .gotbyte

	lda #%00000011	; activate rts
	sta fifo_mcr

.waitbyte	lda fifo_lsr	; check if byte available
	and #$01
	beq .waitbyte

.gotbyte	lda #%00000001	; deactivate rts
	sta fifo_mcr

	lda $de08	; get byte

	rts


; send a byte
ser_tx	subroutine
	pha
.waitlsr	lda fifo_lsr
	and #%01100000
	beq .waitlsr

.waitmsr	lda fifo_msr
	and #%00110000
	beq .waitmsr

	pla
	sta fifo_txd
	rts


ser_flush

	lda #%00000011	; activate rts
	sta fifo_mcr

	lda fifo_lsr	; check if byte available
	and #$01
	beq .nobyte

.waitbyte
	lda $de08	; get byte

	lda fifo_lsr	; check if byte available
	and #$01
	bne .waitbyte

.nobyte	lda #%00000001	; deactivate rts
	sta fifo_mcr

	rts

 endif
