/*

User interface

*/


#define WIN_CLOSEBUTTON 0x01

#define REQ_OK       0x01
#define REQ_OKCANCEL 0x02
#define REQ_YESNO    0x03


typedef struct {
  unsigned char *text;
  unsigned char key;
  unsigned char x;
  unsigned char y;
} option;

typedef struct {
  unsigned char *text;
  unsigned char key;
} button;

typedef struct {
  unsigned char *title;
  unsigned char x;
  unsigned char y;
  unsigned char w;
  unsigned char h;
  unsigned char flags;
  button **buttons;
  unsigned char *backbuffer;
} window;


/* Set screen colors, hide the cursor, clear the screen, print title */
void resetscreen(unsigned char *title);

/* Configure the serial interface */
unsigned char configserial(unsigned char *interface, unsigned char *baudrate);

/* Draw petscii window */
void drawwindow(unsigned char *title, unsigned char x, unsigned char y, unsigned char w, unsigned char h, unsigned char flags, button **buttons);

/* Open a window, return a handle */
window *openwindow(unsigned char *title, unsigned char x, unsigned char y, unsigned char w, unsigned char h, unsigned char flags, button **buttons);

/* Close a window, free resources */
void closewindow(window *win);

/* Print a character */
void __fastcall__ myputchar(unsigned char c);

/* Print a string */
void myputs(unsigned char *c);

/* Show a requester */
unsigned char showrequester(unsigned char *title, unsigned char *message, unsigned char buttons);

/* Display directory list */
void showdir(directory *dir, unsigned char maxlines, unsigned char startline);
void printcurrent(directory *dir, unsigned char startline);
void printrevcurrent(directory *dir, unsigned char startline);
void scrolldirup(unsigned char maxlines, unsigned char startline);
void scrolldirdown(unsigned char maxlines, unsigned char startline);
void cleardir(unsigned char maxlines, unsigned char startline);
