; print a 16-bit integer
; lsb in x, msb in a
print16	subroutine
	sta acc+1
	stx acc

	ldx #4
.nextdig	jsr div
	lda ext
	sta .num,x
	dex
	bpl .nextdig

.firstdig	inx
	cpx #5
	beq .print0
	lda .num,x
	beq .firstdig

.ptnxtdig	clc
	adc #"0"
	jsr bsout
	inx
	cpx #5
	beq .pt16done
	lda .num,x
	jmp .ptnxtdig

.pt16done	rts

.print0	lda #"0"
	jsr bsout
	rts

.num	dc.b 0,0,0,0,0

; 16/16-bit division, from the fridge
; acc/aux -> acc, remainder in ext
div	subroutine
	lda #0
	sta ext+1
	ldy #$10
.dloop	asl acc
	rol acc+1
	rol
	rol ext+1
	pha
	cmp aux
	lda ext+1
	sbc aux+1
	bcc .div2
	sta ext+1
	pla
	sbc aux
	pha
	inc acc
.div2	pla
	dey
	bne .dloop
	sta ext
	rts


acc	dc.w 0
aux	dc.w 10	; constant
ext	dc.w 0


; Steve Judd's PRIMM clone (see C128 kernal)
; On exit, A and X are thoroughly hosed.
primm	subroutine
	pla
	tax	     ;lo byte
	pla
	inx
	bne .cont
	clc
	adc #1
.cont	jsr .print
	pha	     ;lo byte
	txa
	pha	     ;hi byte
	rts

.print	sta .loop+2
.loop	lda $a000,x
	beq .done
	jsr $ffd2
	inx
	bne .loop
	inc .loop+2
	bne .loop
.done
	lda .loop+2
	rts
