use strict;


# load a file or CD to a dir
# receive <filename
#   send ? or ! or .
# iff ? or ! send 16-bit length
# iff ! send data
sub loadreq($) {
  my $req = shift;
  my ($head, $fname, $l, $m, $len);
  my @names;

  if ($req =~ s/^jpg2mci://i) {
    print "Setting jpg to MCI flag\n";
    $::jpg2mci = 1;
  } else {
    $::jpg2mci = 0;
  }

  if ($::cd =~ /\.d64$/i) { # handle d64 loading
    loadd64($req);
    goto LR_DONE;
  }

  $req = pettoa($req);

  # does it look like an URL?
  if ($req =~ /^[a-zA-Z]+:\/\//) {
    loadurl($req);
    goto LR_DONE;
  }

  ($head, $fname, $_) = splithead($req);

  if ($fname =~ /^\$/) {
    print "list $fname\n";
    senddir($fname);
    goto LR_DONE;
  }

  @names = glob($fname); # take care of any wildcards
  $fname = $names[0];

  if (! -e $fname) {
    print "$fname doesn't exist\n";
    sendc("?"); # doesn't exist
    goto LR_DONE;
  }

  if (-d $fname) {
    print "cd $fname\n";
    if (chdir($fname)) {
      sendc(".");
    } else {
      print "failed!\n";
      sendc("?");
    }
    goto LR_DONE;
  }

  if (!-f $fname) {
    print "$req is weird\n";
    sendc("?");	# not a file nor a dir
    goto LR_DONE;
  }

  if ($fname =~ /\.d64$/i) {
    if (&opend64($fname) == 1) {
      $::cd = $fname;
      sendc(".");
    } else {
      print "Failed to open $fname\n";
      sendc("?");
    }
    goto LR_DONE;
  }

  print "loading $fname\n";
  if (open(FILE, $fname)) {
    my $file = "";

    binmode(FILE);
    while (<FILE>) {
      $file .= $_;
    }
    close(FILE);
    send_wsize($file);
  } else {
    sendc("?");
  }

 LR_DONE:
}


return(1);
