use strict;


# save a file
# receive >filename
#   send ? or !
# receive 16-bit length of data
# receive 16-bit start address
# receive data
sub savereq($) {
  my $req = shift;
  my ($replace, $head, $fname, $data, $count, $len, $left);

  # d64 mounted?
  if ($::cd =~ /\.d64$/i) {
    # unimplemented
    sendc("?");
    goto SR_DONE;
  }

  ($head, $fname, $replace) = splithead($req);
  $fname = pettoa($fname);
  $fname =~ tr/\/\\/--/; # slashes are evil

  # check if file exists
  if (-e $fname) {
    # @0: overwrites
    unless ($replace) {
      sendc("?");
      goto SR_DONE;
    }
  }

  # open file to write
  unless (open(S, ">$fname")) {
    sendc("?");
  }
  binmode(S);

  # good to go
  sendc("!");

  # get the file length
  $::ob->read_const_time(100000); # avoid timeouts
  ($count, $data) = $::ob->read(2);
  die "didn't get 16-bit length: $count" if ($count != 2);
  # compensate for load addr
  $len = 2 + unpack("S", $data);
  $::ob->read_const_time(100); # back to normal

  print "saving $len bytes to $fname\n";

  # get load addr
  ($count, $data) = $::ob->read(2);
  print S $data;

  print "load address: " . unpack("S", $data) . "\n";

  # count bytes left to receive
  $left = $len - 2;

  # receive and save
  while ($left) {
    ($count, $data) = $::ob->read(min(256,$left));
    print S $data;
    $left -= $count;
  }

  print "saved $len bytes to $fname\n";
  # all done
  close(S);

 SR_DONE:
}


return(1);
