	processor 6502

counter	equ $03
scrollpointer	equ $05
colram	equ $1000
page2chars	equ $1400

	org $0801

	dc.w nextline
	dc.w 2001
	dc.b $9e,"2061"
	dc.b 0
nextline	dc.w 0


main	subroutine
	; chars @ 0C00, bitmap @ 2000
	lda $d018
	pha
	lda #$38
	sta $d018
	; multicolour
	lda $d016
	pha
	lda #$18
	sta $d016
	; bitmap mode
	lda $d011
	pha
	lda #$3b
	sta $d011
	; bank
	lda $dd00
	pha

	; load colram and page1 chars
	ldx #0
.copyloop	lda colram,x
	sta $d800,x
	lda colram+256,x
	sta $d900,x
	lda colram+512,x
	sta $da00,x
	lda colram+768,x
	sta $db00,x
	lda page2chars,x
	sta $6400,x
	lda page2chars+256,x
	sta $6500,x
	lda page2chars+512,x
	sta $6600,x
	lda page2chars+768,x
	sta $6700,x
	inx
	bne .copyloop

	; background colours
	lda $d020
	pha
	lda $d021
	pha
	lda #0
	sta $d020
	lda colram+1000
	sta $d021

display	subroutine
	lda #251
waitframe	cmp $d012
	bne waitframe
	lda $d016	; interlace
	eor #1
	sta $d016
	lda $dd00	; flip image
	eor #1
	sta $dd00
	lda $d018
	eor #$a8
	sta $d018

	lda #255
waitframe2	cmp $d012
	bne waitframe2

	lda 198
	beq display

	lda #0
	sta 198

	pla	; restore
	sta $d021
	pla
	sta $d020
	pla
	sta $dd00
	pla
	sta $d011
	pla
	sta $d016
	pla
	sta $d018

	lda #147	; clear and exit
	jsr $ffd2
	rts
